'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _index = require('../../parsec/index');

var _index2 = require('../../stream/index');

var _index3 = _interopRequireDefault(_index2);

var _token = require('./token');

var _token2 = _interopRequireDefault(_token);

var _textParser = require('./text-parser');

var _textParser2 = _interopRequireDefault(_textParser);

var _titleParser = require('./title-parser');

var _titleParser2 = _interopRequireDefault(_titleParser);

var _bulletParser = require('./bullet-parser');

var _bulletParser2 = _interopRequireDefault(_bulletParser);

var _codeLineParser = require('./code-line-parser');

var _codeLineParser2 = _interopRequireDefault(_codeLineParser);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function mdLine() {
    return _index.F.try(_titleParser2.default.title()).or(_index.F.try(_codeLineParser2.default.codeLine())).or(_index.F.try(_bulletParser2.default.bullet())).or(_index.F.try(_textParser2.default.formattedParagraph())).or(_token2.default.lineFeed());
} /**
   * Created by Simon on 16/12/2016.
   */

function document() {
    return mdLine().rep().map(function (item) {
        return item.array();
    });
}

function _parseLine(line) {
    return mdLine().parse(_index3.default.ofString(line), 0);
}

exports.default = {
    mdLine: mdLine,

    parseLine: function parseLine(line) {
        return _parseLine(line, 0);
    },
    parse: function parse(stream, offset) {
        return document().parse(stream, offset);
    }
};
//# sourceMappingURL=markdown-parser.js.map