'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _jsonparser = require('../../../lib/standard/json/jsonparser');

var _jsonparser2 = _interopRequireDefault(_jsonparser);

var _index = require('../../../lib/stream/index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
  ======== A Handy Little Nodeunit Reference ========
  https://github.com/caolan/nodeunit
  Test methods:
    test.expect(numAssertions)
    test.done()
  Test assertions:
    test.ok(value, [message])
    test.equal(actual, expected, [message])
    test.notEqual(actual, expected, [message])
    test.(actual, expected, [message])
    test.notDeepEqual(actual, expected, [message])
    test.strictEqual(actual, expected, [message])
    test.notStrictEqual(actual, expected, [message])
    test.throws(block, [error], [message])
    test.doesNotThrow(block, [error], [message])
    test.ifError(value)
*/

function sampleTest(sample, test) {
    test.expect(1);

    // tests here
    _fs2.default.readFile('./src/test/standard/json/samples/' + sample, function (err, data) {
        if (err) {
            throw err;
        }

        var result = {
            isAccepted: function isAccepted() {
                return false;
            }
        };

        try {
            result = _jsonparser2.default.parse(_index2.default.ofString(data.toString()));
        } catch (e) {
            console.log(e.stack);
        }

        if (!result.isAccepted()) {
            console.log(result);
        }

        test.ok(result.isAccepted(), 'Well formed JSON');
        test.done();
    });
}

exports.default = {
    setUp: function setUp(done) {
        done();
    },

    'test 1k': function test1k(test) {
        sampleTest('1k.json', test);
    },

    'test 100k': function test100k(test) {
        sampleTest('100k.json', test);
    }
};
//# sourceMappingURL=jsonsample_test.js.map