'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _markdownParser = require('../../../lib/standard/markdown/markdown-parser');

var _markdownParser2 = _interopRequireDefault(_markdownParser);

var _index = require('../../../lib/stream/index');

var _index2 = _interopRequireDefault(_index);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var value = undefined;
var expected = undefined;

function testFile(sample) {
    var sampleFileName = _path2.default.join(__dirname, 'samples/' + sample + '-test.md');
    var expectedFileName = _path2.default.join(__dirname, 'samples/' + sample + '-expected.json');
    var sampleContent = _fs2.default.readFileSync(sampleFileName).toString();
    var sampleExpected = _fs2.default.readFileSync(expectedFileName).toString();

    var parsing = _markdownParser2.default.parse(_index2.default.ofString(sampleContent));
    value = parsing.value;
    expected = JSON.parse(sampleExpected);
}

exports.default = {
    setUp: function setUp(done) {
        done();
    },

    'parseTrivial test': function parseTrivialTest(test) {
        testFile('trivial');
        test.deepEqual(value, expected, 'bad value for file "trivial-test.md"');
        test.done();
    },

    'parseParagraph test': function parseParagraphTest(test) {
        testFile('paragraph');
        test.deepEqual(value, expected, 'bad value for file "trivial-test.md"');
        test.done();
    }
};
//# sourceMappingURL=file-parser-test.js.map